﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;
using Infragistics.WebUI.WebSchedule;

public partial class Calendar_Off : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //this.WebMonthView1.Style.Add(HtmlTextWriterStyle.Overflow, "hidden");

        this.wsInfo.AppointmentFormPath = "WebSchedule/AppointmentAdd.aspx";
        this.wsInfo.ReminderFormPath = "WebSchedule/Reminder.aspx";

        IList resources = null;
        ICollection appointments = null;




        if (!IsPostBack)
        {

            resources = GetResources_By_office("PPL-GIB", "AY");

            appointments = GetAppointments("PPL-GIB","AY");

            Session["WebSchdeuleObjects"] = new object[] { resources, appointments };
        }
        else
        {
            object[] objects = Session["WebSchdeuleObjects"] as object[];

            resources = objects[0] as IList;
            appointments = objects[1] as ICollection;
        }

        WebScheduleGenericProviderBindings();

        WebScheduleGenericProvider1.ActivityDataSource = appointments;
        WebScheduleGenericProvider1.VarianceDataSource = appointments;

        WebScheduleGenericProvider1.ResourceDataSource = resources;
    }


    protected void Btn_Load_Click(object sender, EventArgs e)
    {

    }




    private IList GetAppointments(string off, string user)
    {
        List<MyAppointment> appointments = new List<MyAppointment>();

        SQLcls sql = new SQLcls();

        DataTable dt = null;

        if (user.Trim().ToLowerInvariant().Equals("all"))
        {
            dt = sql.Select_APP_Office(off);
        }
        else
        {
            dt = sql.Select_All_APP(user);
        }



        appointments.Add(
                 CreateAppointment(1, DateTime.Today.AddHours(9), 3600, "", "", "", false, "0"));

        foreach (DataRow item in dt.Rows)
        {
            MyAppointment app = new MyAppointment();

            app.StartDateTimeUtc = DateTime.Parse(item["startDateTimeUtc"].ToString());
            app.Duration = int.Parse(item["Duration"].ToString());
            app.Subject = item["Subject"].ToString();
            app.AllDayEvent = bool.Parse(item["AllDayEvent"].ToString());
            app.Location = item["Location"].ToString();
            app.Description = item["ActivityDescription"].ToString();
            app.Status = int.Parse(item["Status"].ToString());
            app.EnableReminders = bool.Parse(item["EnableReminder"].ToString());

            app.ShowTimeAs = int.Parse(item["ShowTimeAs"].ToString());
            app.Importance = int.Parse(item["Importance"].ToString());

            //app.VarianceID = item["VarianceID"].ToString(); 
            //app.RecurrencePattern = item["RecurrencePattern"].ToString(); recurrencePattern;
            //app.RecurrenceID =int.Parse( item["RecurrenceID"].ToString()); 
            app.OriginalStartDateTimeUtc = string.IsNullOrEmpty(item["OriginalStartDateTimeUtc"].ToString()) ? (DateTime?)null : DateTime.Parse(item["OriginalStartDateTimeUtc"].ToString());
            app.ResourceKey = item["ResourceID"].ToString().Trim();

             
            appointments.Add(app);

        }

        return appointments;
    }


    private IList GetResources_By_office(string off, string user)
    {
        SQLcls sql = new SQLcls();

        DataTable dt = null;

        if (user.Trim().ToLowerInvariant().Equals("all"))
        {
            dt = sql.Select_Traders_ByOffice(off);
        }
        else
        {
            dt = sql.Select_Traders_ByID(user);
        }


        List<MyResource> resources = new List<MyResource>();

        //DataTable dt = sql.Select_Traders_ByOffice(off);

        foreach (DataRow item in dt.Rows)
        {
            MyResource mr = new MyResource();

            mr.ID = item["user_id"].ToString().Trim();
            mr.ResourceName = item["Name"].ToString();
            mr.ResourceDescription = item["Name"].ToString();
            mr.EmailAddress = item["e_mail"].ToString();


            resources.Add(mr);
        }


        return resources;
    }



    protected void WebScheduleGenericProviderBindings()
    {
        WebScheduleGenericProvider1.AppointmentBinding.DescriptionMember = "Description";
        WebScheduleGenericProvider1.AppointmentBinding.DataKeyMember = "ID";
        WebScheduleGenericProvider1.AppointmentBinding.DurationMember = "Duration";
        WebScheduleGenericProvider1.AppointmentBinding.EnableReminderMember = "EnableReminders";
        WebScheduleGenericProvider1.AppointmentBinding.LocationMember = "Location";
        WebScheduleGenericProvider1.AppointmentBinding.OriginalStartDateTimeUtcMember = "OriginalStartDateTimeUtc";
        //WebScheduleGenericProvider1.AppointmentBinding.RecurrenceKeyMember = "RecurrenceID";
        WebScheduleGenericProvider1.AppointmentBinding.ResourceKeyMember = "ResourceKey";
        WebScheduleGenericProvider1.AppointmentBinding.AllDayEventMember = "AllDayEvent";
        //WebScheduleGenericProvider1.AppointmentBinding.RecurrencePatternMember = "RecurrencePattern";
        WebScheduleGenericProvider1.AppointmentBinding.ShowTimeAsMember = "ShowTimeAs";
        WebScheduleGenericProvider1.AppointmentBinding.StartDateTimeUtcMember = "StartDateTimeUtc";
        WebScheduleGenericProvider1.AppointmentBinding.StatusMember = "Status";
        WebScheduleGenericProvider1.AppointmentBinding.SubjectMember = "Subject";
        //WebScheduleGenericProvider1.AppointmentBinding.VarianceKeyMember = "VarianceID";
        WebScheduleGenericProvider1.AppointmentBinding.ImportanceMember = "Importance";

        WebScheduleGenericProvider1.VarianceBinding.DescriptionMember = "Description";
        WebScheduleGenericProvider1.VarianceBinding.DataKeyMember = "ID";
        WebScheduleGenericProvider1.VarianceBinding.DurationMember = "Duration";
        WebScheduleGenericProvider1.VarianceBinding.EnableReminderMember = "EnableReminders";
        WebScheduleGenericProvider1.VarianceBinding.LocationMember = "Location";
        WebScheduleGenericProvider1.VarianceBinding.OriginalStartDateTimeUtcMember = "OriginalStartDateTimeUtc";
        //WebScheduleGenericProvider1.VarianceBinding.RecurrenceKeyMember = "RecurrenceID";
        WebScheduleGenericProvider1.VarianceBinding.ResourceKeyMember = "ResourceKey";
        WebScheduleGenericProvider1.VarianceBinding.AllDayEventMember = "AllDayEvent";
        //WebScheduleGenericProvider1.VarianceBinding.RecurrencePatternMember = "RecurrencePattern";
        WebScheduleGenericProvider1.VarianceBinding.ShowTimeAsMember = "ShowTimeAs";
        WebScheduleGenericProvider1.VarianceBinding.StartDateTimeUtcMember = "StartDateTimeUtc";
        WebScheduleGenericProvider1.VarianceBinding.StatusMember = "Status";
        WebScheduleGenericProvider1.VarianceBinding.SubjectMember = "Subject";
        //WebScheduleGenericProvider1.VarianceBinding.VarianceKeyMember = "VarianceID";
        WebScheduleGenericProvider1.VarianceBinding.ImportanceMember = "Importance";

        WebScheduleGenericProvider1.ResourceBinding.DataKeyMember = "ID";
        WebScheduleGenericProvider1.ResourceBinding.NameMember = "ResourceName";
        WebScheduleGenericProvider1.ResourceBinding.DescriptionMember = "ResourceDescription";
        WebScheduleGenericProvider1.ResourceBinding.EmailAddressMember = "EmailAddress";

    }


    protected MyAppointment CreateAppointment(int id, DateTime startDateTime, int appointmentDuration,
    string appName, string location, string appDescription, bool allDayEvent, string resourceID)
    {
        return new MyAppointment(
                    id,
                    startDateTime.ToUniversalTime(),
                    appointmentDuration,
                    appName,
                    allDayEvent,
                    location,
                    appDescription,
                    1,
                    false,
                    1,
                    1,
                    Guid.NewGuid().ToString(),
                    null,
                    -1,
                    null,
                    resourceID
                );
    }


    protected void wsInfo_VarianceAdding(object sender, CancelableActivityEventArgs e)
    {
        e.Activity.DataKey = new Random().Next();

    }

    protected void wsInfo_ActivityAdding(object sender, CancelableActivityEventArgs e)
    {
        e.Activity.DataKey = new Random().Next();
        SQLcls sql = new SQLcls();

        sql.Insert_App((Appointment)e.Activity);
    }

}
